/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.PlayPKManage
 *  fire.pb.map.MapConfig
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.map.Transfer
 *  fire.pb.mission.Module
 *  fire.pb.mission.SFairylandStatus
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.RolePos
 *  xtable.Roleposes
 */
package fire.pb.mission.fairyland;

import fire.pb.battle.PlayPKManage;
import fire.pb.map.MapConfig;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.map.Transfer;
import fire.pb.mission.Module;
import fire.pb.mission.SFairylandStatus;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import java.util.List;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.RolePos;
import xtable.Roleposes;

public class PAbsentFairyland
extends Procedure {
    private long roleid;
    private boolean hasDreamTask;

    public PAbsentFairyland(long roleid, boolean hasDreamTask) {
        this.roleid = roleid;
        this.hasDreamTask = hasDreamTask;
    }

    protected boolean process() throws Exception {
        Role role = RoleManager.getInstance().getRoleByID(this.roleid);
        if (role == null) {
            return false;
        }
        long originalScene = role.getScene();
        if (!TeamManager.isInTeam((long)this.roleid)) {
            RolePos rolePos = Roleposes.get((Long)this.roleid);
            int mapid = rolePos.getMapid();
            int posx = rolePos.getPosx();
            int posy = rolePos.getPosy();
            if (mapid == 0) {
                MapConfig conf = PlayPKManage.getMapConfig((int)1007);
                mapid = 1007;
                posx = conf.getXjPos();
                posy = conf.getYjPos();
            }
            Transfer.justGotoWhileCommit((long)this.roleid, (long)mapid, (int)posx, (int)posy, (int)516022);
            SFairylandStatus sds = new SFairylandStatus();
            if (this.hasDreamTask) {
                sds.status = 3;
                rolePos.setStatus(3);
            } else {
                sds.status = 1;
                rolePos.setStatus(1);
            }
            PAbsentFairyland.psendWhileCommit((long)this.roleid, (Protocol)sds);
            MessageMgr.psendMsgNotifyWhileCommit((long)this.roleid, (int)142069, null);
        } else {
            Team team = TeamManager.getTeamByRoleId((long)this.roleid);
            if (team == null) {
                return true;
            }
            if (team.isTeamLeader(this.roleid)) {
                RolePos leaderPos = Roleposes.get((Long)this.roleid);
                int mapid = leaderPos.getMapid();
                int posx = leaderPos.getPosx();
                int posy = leaderPos.getPosy();
                if (mapid == 0) {
                    MapConfig conf = PlayPKManage.getMapConfig((int)1007);
                    mapid = 1007;
                    posx = conf.getXjPos();
                    posy = conf.getYjPos();
                }
                List roleids = team.getNormalMemberIds();
                for (Long mem : roleids) {
                    Role memRole;
                    RolePos rolePos = Roleposes.get((Long)mem);
                    if (rolePos == null || (memRole = RoleManager.getInstance().getRoleByID(mem.longValue())) == null || memRole.getScene() != originalScene) continue;
                    if (Module.getInstance().hasUnfinishedFairylandMission(mem.longValue()) > 0) {
                        rolePos.setStatus(3);
                    } else {
                        rolePos.setStatus(1);
                        Roleposes.remove((Long)mem);
                    }
                    SFairylandStatus sds = new SFairylandStatus(rolePos.getStatus());
                    PAbsentFairyland.psendWhileCommit((long)mem, (Protocol)sds);
                    MessageMgr.psendMsgNotifyWhileCommit((long)mem, (int)142069, null);
                }
                Transfer.justGotoWhileCommit((long)this.roleid, (long)mapid, (int)posx, (int)posy, (int)516022);
            } else {
                team.setTeamMemberStateWithSP(this.roleid, 2);
                RolePos rolePos = Roleposes.get((Long)this.roleid);
                if (this.hasDreamTask) {
                    rolePos.setStatus(3);
                } else {
                    rolePos.setStatus(1);
                    Roleposes.remove((Long)this.roleid);
                }
                int mapid = rolePos.getMapid();
                int posx = rolePos.getPosx();
                int posy = rolePos.getPosy();
                if (mapid == 0) {
                    MapConfig conf = PlayPKManage.getMapConfig((int)1007);
                    mapid = 1007;
                    posx = conf.getXjPos();
                    posy = conf.getYjPos();
                }
                Transfer.justGotoWhileCommit((long)this.roleid, (long)mapid, (int)posx, (int)posy, (int)516019);
                SFairylandStatus sds = new SFairylandStatus(rolePos.getStatus());
                PAbsentFairyland.psendWhileCommit((long)this.roleid, (Protocol)sds);
                MessageMgr.psendMsgNotifyWhileCommit((long)this.roleid, (int)142069, null);
            }
        }
        return true;
    }
}

